"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.PropTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _toetag = require("toetag");

var _icon = require("./icon");

var _icon2 = _interopRequireDefault(_icon);

var _container = require("./container");

var _reactJssPresetCivicsource = require("react-jss-preset-civicsource");

var _reactJssPresetCivicsource2 = _interopRequireDefault(_reactJssPresetCivicsource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
	innerAlert: {
		marginBottom: _toetag.bootstrap.paddingBaseVertical,
		display: "inline-block",
		textAlign: "left"
	},
	msgContainer: {
		display: "inline-block"
	},
	icon: {
		verticalAlign: "top",
		fontSize: _toetag.bootstrap.fontSizeH4,
		paddingRight: _toetag.bootstrap.paddingLargeHorizontal,
		opacity: 0.2
	},
	headline: {
		margin: 0,
		marginBottom: _toetag.bootstrap.paddingBaseVertical
	},
	body: {
		maxWidth: "40em"
	}
};

var Alert = function Alert(_ref) {
	var _ref$type = _ref.type;
	var type = _ref$type === undefined ? "info" : _ref$type;
	var children = _ref.children;
	var headline = _ref.headline;
	var onDismiss = _ref.onDismiss;
	var _ref$dismissTitle = _ref.dismissTitle;
	var dismissTitle = _ref$dismissTitle === undefined ? "Dismiss" : _ref$dismissTitle;
	var classes = _ref.sheet.classes;
	var _ref$showIcon = _ref.showIcon;
	var showIcon = _ref$showIcon === undefined ? true : _ref$showIcon;

	var isDismissable = !!onDismiss;
	var css = "alert " + (isDismissable ? "alert-dismissible" : "") + " alert-" + type + " " + classes.innerAlert;
	var dismiss = isDismissable ? _react2.default.createElement(
		"button",
		{ type: "button", className: "close", title: dismissTitle, onClick: onDismiss },
		"\xD7"
	) : null;

	return _react2.default.createElement(
		"div",
		null,
		" ",
		_react2.default.createElement(
			"div",
			{ className: css },
			dismiss,
			showIcon ? _react2.default.createElement(_icon2.default, { className: classes.icon, type: type }) : null,
			_react2.default.createElement(
				"div",
				{ className: classes.msgContainer },
				headline ? _react2.default.createElement(
					"h4",
					{ className: classes.headline },
					headline
				) : null,
				_react2.default.createElement(
					"div",
					{ className: classes.body },
					children
				)
			)
		)
	);
};

var AlertTimer = function (_Component) {
	_inherits(AlertTimer, _Component);

	function AlertTimer(props) {
		_classCallCheck(this, AlertTimer);

		return _possibleConstructorReturn(this, (AlertTimer.__proto__ || Object.getPrototypeOf(AlertTimer)).call(this, props));
	}

	_createClass(AlertTimer, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.setupTimer(this.props.timeout, this.props.onDismiss);
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(_ref2) {
			var timeout = _ref2.timeout;
			var onDismiss = _ref2.onDismiss;

			this.setupTimer(timeout, onDismiss);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			// need to clean up after ourselves
			this.setupTimer();
		}
	}, {
		key: "setupTimer",
		value: function setupTimer(timeout, onDismiss) {
			if (!timeout || !onDismiss) {
				// clear any timer we currently have
				clearTimeout(this.timer);
				this.timer = null;
				this.timerTimeout = null;
			} else {
				if (this.timer && this.timerTimeout != timeout) {
					// the timeout value has changed, setup a new timer
					clearTimeout(this.timer);
					this.timer = null;
				}

				// add new timer if we don't already have one
				if (!this.timer) {
					this.timer = setTimeout(this.dismissAlert.bind(this, onDismiss), timeout + _container.ENTER_TIMEOUT + _container.EXIT_TIMEOUT);
					this.timerTimeout = timeout;
				}
			}
		}
	}, {
		key: "dismissAlert",
		value: function dismissAlert(onDismiss) {
			// clear the timer if it hasn't fired yet
			clearTimeout(this.timer);

			// we don't need to keep track of any timers for this alert anymore
			this.timer = null;
			this.timerTimeout = null;

			// actually dismiss the alert
			onDismiss();
		}
	}, {
		key: "render",
		value: function render() {
			var onDismiss = this.props.onDismiss ? this.dismissAlert.bind(this, this.props.onDismiss) : null;
			return _react2.default.createElement(Alert, _extends({}, this.props, { onDismiss: onDismiss }));
		}
	}]);

	return AlertTimer;
}(_react.Component);

var PropTypes = exports.PropTypes = {
	type: _react.PropTypes.oneOf(["info", "success", "warning", "danger"]),
	headline: _react.PropTypes.string,
	onDismiss: _react.PropTypes.func,
	dismissTitle: _react.PropTypes.string,
	showIcon: _react.PropTypes.bool,
	timeout: _react.PropTypes.number
};

AlertTimer.propTypes = PropTypes;

exports.default = (0, _reactJssPresetCivicsource2.default)(AlertTimer, styles);